import java.io.*;
public class StateChipGenerator{
    public static void main(String[]args){
        String source=args[0];
        String target=source+".txt";
        int linenumber=1;
        try{
            FileInputStream fis=new FileInputStream(source);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            int wordlength=-1;
            int wordlengthlinenumber=-1;
            int errors=0;
            State start=null;
            State end=null;
            DataWord startdw=null;
            DataWord enddw=null;
            boolean datastart=false;
            String filetype=dis.readLine();
            if(filetype.equals("statechipgenerator")){
                System.out.println("compiling StateChipGenerator source "+source);
            }
            else{
                System.out.println("This is not a StateChipGenerator source: exit");
                System.exit(0);
            }
            linenumber=linenumber+1;
            String inp=null;
            while((inp=dis.readLine())!=null){
                linenumber=linenumber+1;
                if(datastart||inp.equals("data")){
                    boolean dataadd=true;
                    while(dataadd){
                        if(!datastart){
                            inp=dis.readLine();
                        }
                        else{
                            linenumber=linenumber-1;
                            datastart=false;
                        }
                        if(inp==null){
                            dataadd=false;
                            inp="";
                        }
                        else if(inp.equals("firststate")){
                            dataadd=false;
                        }
                        else if(inp.equals("state")){
                            dataadd=false;
                        }
                        else{
                            int dwlength=inp.length();
                            if(wordlength==-1){
                                wordlength=dwlength;
                                wordlengthlinenumber=linenumber;
                            }
                            else{
                                if(wordlength!=dwlength){
                                    System.out.println("error: data word length "+dwlength+" in line "+linenumber+" != first word length "+wordlength+" in line "+wordlengthlinenumber);
                                    errors=errors+1;
                                }
                            }
                            String[]datastr=new String[dwlength];
                            for(int i=0;i<dwlength;i++){
                                String si=inp.substring(i,i+1);
                                if(si.equals("0")||si.equals("1")){
                                    datastr[i]=si;
                                }
                                else{
                                    System.out.println("wrong character "+si+" in data, must be 0 or 1 in line "+linenumber);
                                    errors=errors+1;
                                }
                            }
                            DataWord cur=new DataWord(datastr,dwlength);
                            if(startdw==null){
                                startdw=cur;
                                enddw=cur;
                            }
                            else{
                                enddw.next=cur;
                                enddw=enddw.next;
                            }
                        }
                        linenumber=linenumber+1;
                    }
                }
                boolean firststate=false;
                boolean astate=false;
                datastart=false;
                if(inp.equals("firststate")){
                    firststate=true;
                    astate=true;
                }
                else if(inp.equals("state")){
                    astate=true;
                }
                while(astate){
                    String statename=dis.readLine();
                    State s=new State(statename,firststate,linenumber);
                    linenumber=linenumber+1;
                    boolean statechange=true;
                    while(statechange){
                        inp=dis.readLine();
                        if(inp==null){
                            firststate=false;
                            astate=false;
                            datastart=true;
                            statechange=false;
                        }
                        else if(inp.equals("firststate")){
                            firststate=true;
                            astate=true;
                            statechange=false;
                        }
                        else if(inp.equals("state")){
                            firststate=false;
                            astate=true;
                            statechange=false;
                        }
                        else if(inp.equals("data")){
                            firststate=false;
                            astate=false;
                            datastart=true;
                            statechange=false;
                        }
                        else{
                            int ind=inp.indexOf("->");
                            if(ind==-1){
                                System.out.println("This is not a state change: missing ->");
                                System.out.println("line: "+linenumber);
                                errors=errors+1;
                            }
                            else{
                                int inplen=inp.length();
                                String data=inp.substring(0,ind);
                                if(ind+2>=inplen){
                                    System.out.println("This is not a state change: missing new state after ->");
                                    System.out.println("line: "+linenumber);
                                    errors=errors+1;
                                }
                                else{
                                    String nextstate=inp.substring(ind+2);
                                    int datalength=data.length();
                                    if(wordlength==-1){
                                        wordlength=datalength;
                                        wordlengthlinenumber=linenumber;
                                    }
                                    else{
                                        if(wordlength!=datalength){
                                            System.out.println("error: state change word length "+datalength+" in line "+linenumber+" != first word length "+wordlength+" in line "+wordlengthlinenumber);
                                            errors=errors+1;
                                        }
                                    }
                                    String[]datastr=new String[datalength];
                                    boolean always=true;
                                    int incount=0;
                                    for(int i=0;i<datalength;i++){
                                        String si=data.substring(i,i+1);
                                        if(si.equals("0")||si.equals("1")||si.equals("*")){
                                            if(si.equals("0")||si.equals("1")){
                                                always=false;
                                                incount=incount+1;
                                            }
                                            datastr[i]=si;
                                        }
                                        else{
                                            System.out.println("wrong character "+si+" in state change, must be 0, 1 or * in line "+linenumber);
                                            errors=errors+1;
                                        }
                                    }
                                    s.addStateChange(datastr,datalength,always,nextstate,linenumber,incount);
                                }
                            }
                        }
                        linenumber=linenumber+1;
                        if((astate||datastart)&&(!statechange)){
                            if(start==null){
                                start=s;
                                end=s;
                            }
                            else{
                                end.next=s;
                                end=end.next;
                            }
                        }
                    }
                }
            }
            int states=0;
            State curs=start;
            while(curs!=null){
                states++;
                curs=curs.next;
            }
            String[]statename=new String[states];
            int[]namelinenumber=new int[states];
            int statesi=0;
            curs=start;
            while(curs!=null){
                statename[statesi]=curs.statename;
                namelinenumber[statesi]=curs.linenumber;
                statesi++;
                curs=curs.next;
            }
            for(int i=0;i<states;i++){
                for(int j=i+1;j<states;j++){
                    if(statename[i].equals(statename[j])){
                        System.out.println("double state name: "+statename[i]+" in line "+namelinenumber[i]+" and "+statename[j]+" in line "+namelinenumber[j]);
                        errors=errors+1;
                    }
                }
            }
            curs=start;
            while(curs!=null){
                errors=errors+curs.find(statename);
                curs=curs.next;
            }
            if(errors>0){
                System.out.println(""+errors+" errors: source not compiled");
                System.exit(0);
            }
            System.out.println("no errors found in source");
            FileOutputStream fos=new FileOutputStream(target);
            PrintStream ps=new PrintStream(fos);
            GloCounter ands=new GloCounter();
            GloCounter ors=new GloCounter();
            int[]statesoutor=new int[statename.length];
            curs=start;
            while(curs!=null){
                ps.println("MODULE STATE"+curs.statename+"{");
                ps.println("CYCLE 1;");
                for(int i=0;i<wordlength;i++){
                    ps.println("IN wordin"+(i+1)+";");
                }
                for(int i=0;i<states;i++){
                    ps.println("IN in"+statename[i]+";");
                }
                for(int i=0;i<states;i++){
                    ps.println("OUT out"+statename[i]+";");
                }
                ps.println("OR"+states+" statesactive;");
                ors.add(states);
                StateChange scur=curs.start;
                int i=0;
                while(scur!=null){
                    for(int j=0;j<scur.datalength;j++){
                        if(scur.datastr[j].equals("0")){
                            ps.println("INV inv"+(i+1)+"x"+(j+1)+"in inv"+(i+1)+"x"+(j+1)+"out;");
                        }
                    }
                    ps.println("AND"+scur.incount+" globand"+(i+1)+";");
                    ands.add(scur.incount);
                    i=i+1;
                    scur=scur.next;
                }
                for(i=0;i<statename.length;i++){
                    statesoutor[i]=0;
                    scur=curs.start;
                    int j=0;
                    while(scur!=null){
                        if(statename[i].equals(scur.nextstate)){
                            statesoutor[i]=statesoutor[i]+1;
                        }
                        j=j+1;
                        scur=scur.next;
                    }
                    ps.println("OR"+statesoutor[i]+" globor"+(i+1)+";");
                    ors.add(statesoutor[i]);
                    ps.println("AND activeandchange"+(i+1)+"in1 activeandchange"+(i+1)+"in2 activeandchange"+(i+1)+"out;");
                }
                ps.println("OR"+(statename.length-1)+" change;");
                ors.add(statename.length-1);
                ps.println("INV changeinvin changeinvout;");
                ps.println("AND activeandnochangein1 activeandnochangein2 activeandnochangeout;");
                ps.println("OR activeandnochangeorselfin1 activeandnochangeorselfin2 activeandnochangeorselfout;");
                if(curs.firststate){
                    ps.println("INITFIRST initfirst;");
                    ps.println("OR firstorin1 firstorin2 firstorout;");
                }

                for(i=0;i<statename.length;i++){
                    if(statename[i].equals(curs.statename)&&curs.firststate){
                        ps.println("CONNECT firstorout statesactive.in"+(i+1)+";");
                    }
                    else{
                        ps.println("CONNECT in"+statename[i]+" statesactive.in"+(i+1)+";");
                    }
                }
                scur=curs.start;
                i=0;
                while(scur!=null){
                    int jb=0;
                    for(int j=0;j<scur.datalength;j++){
                        if(scur.datastr[j].equals("0")){
                            ps.println("CONNECT wordin"+(j+1)+" inv"+(i+1)+"x"+(j+1)+"in;");
                            ps.println("CONNECT inv"+(i+1)+"x"+(j+1)+"out globand"+(i+1)+".in"+(jb+1)+";");
                            jb=jb+1;
                        }
                        else if(scur.datastr[j].equals("1")){
                            ps.println("CONNECT wordin"+(j+1)+" globand"+(i+1)+".in"+(jb+1)+";");
                            jb=jb+1;
                        }
                    }
                    i=i+1;
                    scur=scur.next;
                }
                for(i=0;i<statename.length;i++){
                    int statespos=0;
                    scur=curs.start;
                    int j=0;
                    while(scur!=null){
                        if(statename[i].equals(scur.nextstate)){
                            ps.println("CONNECT globand"+(j+1)+".out globor"+(i+1)+".in"+(statespos+1)+";");
                            statespos=statespos+1;
                        }
                        j=j+1;
                        scur=scur.next;
                    }
                    ps.println("CONNECT statesactive.out activeandchange"+(i+1)+"in1;");
                    ps.println("CONNECT globor"+(i+1)+".out activeandchange"+(i+1)+"in2;");
                    if(!statename[i].equals(curs.statename)){
                        ps.println("CONNECT activeandchange"+(i+1)+"out out"+statename[i]+";");
                    }
                    else{
                        ps.println("CONNECT activeandnochangeorselfout out"+statename[i]+";");
                    }
                }
                int selfpos=0;
                int statespos=0;
                for(i=0;i<statename.length;i++){
                    if(statename[i].equals(curs.statename)){
                        selfpos=i;
                    }
                    else{
                        ps.println("CONNECT activeandchange"+(i+1)+"out change.in"+(statespos+1)+";");
                        statespos=statespos+1;
                    }
                }
                ps.println("CONNECT change.out changeinvin;");
                ps.println("CONNECT statesactive.out activeandnochangein1;");
                ps.println("CONNECT changeinvout activeandnochangein2;");
                ps.println("CONNECT activeandnochangeout activeandnochangeorselfin1;");
                ps.println("CONNECT activeandchange"+(selfpos+1)+"out activeandnochangeorselfin2;");
                if(curs.firststate){
                    ps.println("CONNECT initfirst.outb initfirst.in;");
                    ps.println("CONNECT initfirst.out firstorin1;");
                    ps.println("CONNECT in"+curs.statename+" firstorin2;");
                }

                ps.println("}");
                curs=curs.next;
            }
            DataWord curdw=startdw;
            int idw=0;
            while(curdw!=null){
                ps.println("MODULE DATAWORD"+(idw+1)+"{");
                ps.println("CYCLE 1;");
                for(int i=0;i<wordlength;i++){
                    ps.println("IN in"+(i+1)+";");
                }
                ps.println("IN din;");
                for(int i=0;i<wordlength;i++){
                    ps.println("OUT out"+(i+1)+";");
                }
                ps.println("OUT dout;");
                ps.println("CONSTANT d 1;");
                for(int i=0;i<wordlength;i++){
                    ps.println("BIT bitin"+(i+1)+" bitout"+(i+1)+" bitread"+(i+1)+" bitset"+(i+1)+" "+curdw.datastr[i]+";");
                }
                for(int i=0;i<wordlength;i++){
                    ps.println("CONNECT d bitread"+(i+1)+";");
                    ps.println("CONNECT din bitset"+(i+1)+";");
                    ps.println("CONNECT in"+(i+1)+" bitin"+(i+1)+";");
                    ps.println("CONNECT bitout"+(i+1)+" out"+(i+1)+";");
                }
                ps.println("CONNECT d dout;");
                ps.println("}");
                idw=idw+1;
                curdw=curdw.next;
            }
            for(int i=0;i<ands.count.length;i++){
                conj(ps,"AND"+ands.count[i],"AND","and",ands.count[i]);
            }
            for(int i=0;i<ors.count.length;i++){
                conj(ps,"OR"+ors.count[i],"OR","or",ors.count[i]);
            }
            ps.println("MODULE INITFIRST{");
            ps.println("CYCLE 1;");
            ps.println("IN in;");
            ps.println("OUT outb;");
            ps.println("OUT out;");
            ps.println("CONSTANT d 1;");
            ps.println("INV invin invout;");
            ps.println("CONNECT d outb;");
            ps.println("CONNECT in invin;");
            ps.println("CONNECT invout out;");
            ps.println("}");
            ps.println("MODULE main{");
            for(int i=0;i<statename.length;i++){
                ps.println("STATE"+statename[i]+" state"+statename[i]+";");
            }
            for(int i=0;i<idw;i++){
                ps.println("DATAWORD"+(i+1)+" dataword"+(i+1)+";");
            }
            ps.println("CONSTANT c 0;");
            for(int i=0;i<wordlength;i++){
                ps.println("CONNECT c dataword"+idw+".in"+(i+1)+";");
            }
            for(int j=1;j<idw;j++){
                for(int i=0;i<wordlength;i++){
                    ps.println("CONNECT dataword"+(j+1)+".out"+(i+1)+" dataword"+j+".in"+(i+1)+";");
                }
            }
            for(int j=0;j<idw;j++){
                ps.println("CONNECT dataword"+(j+1)+".dout dataword"+(j+1)+".din;");
            }
            for(int i=0;i<statename.length;i++){
                for(int j=0;j<wordlength;j++){
                    ps.println("CONNECT dataword1.out"+(j+1)+" state"+statename[i]+".wordin"+(j+1)+";");
                }
            }
            for(int i=0;i<statename.length;i++){
                for(int j=0;j<statename.length;j++){
                    ps.println("CONNECT state"+statename[i]+".out"+statename[j]+" state"+statename[j]+".in"+statename[i]+";");
                }
            }
            ps.println("}");
            ps.close();
            fos.close();
            System.out.println("scg source compiled successfully");
            System.out.println("AstroChip2.1 source saved in "+target);
        }
        catch(Exception e){
            e.printStackTrace(System.out);
            System.out.println("compile error in line: "+linenumber);
        }
    }
    public static void conj(PrintStream ps,String modulename,String conjtype,String conjname,int conjnum){
        try{
            if(conjnum==0){
                if(conjtype.equals("AND")){
                    ps.println("MODULE "+modulename+"{");
                    ps.println("CYCLE 0;");
                    ps.println("CONSTANT d 1;");
                    ps.println("OUT out;");
                    ps.println("CONNECT d out;");
                    ps.println("}");
                }
                else if(conjtype.equals("OR")){
                    ps.println("MODULE "+modulename+"{");
                    ps.println("CYCLE 0;");
                    ps.println("CONSTANT c 0;");
                    ps.println("OUT out;");
                    ps.println("CONNECT c out;");
                    ps.println("}");
                }
                return;
            }
            ps.println("MODULE "+modulename+"{");
            ps.println("CYCLE 0;");
            for(int i=0;i<conjnum;i++){
                ps.println("IN in"+(i+1)+";");
            }
            ps.println("OUT out;");
            int inputs=conjnum;
            int andscalced=inputs/2;
            int andsinline=inputs/2;
            int firstlinerest=inputs%2;
            if(firstlinerest==1){
                andscalced=andscalced+1;
                if(inputs==1){
                    andscalced=0;
                }
            }
            while(andsinline>1){
                int linerest=andsinline%2;
                andsinline=andsinline/2;
                andscalced=andscalced+andsinline;
                if(linerest==1){
                    andscalced=andscalced+1;
                }
            }
            for(int i=0;i<andscalced;i++){
                ps.println(conjtype+" "+conjname+(i+1)+"in1 "+conjname+(i+1)+"in2 "+conjname+(i+1)+"out;");
            }
            int inputnumber=-1;
            int number=-1;
            int number2=-1;
            int ands1=-1;
            int ands=-1;
            int linebegin=0;
            int nextlinebegin=inputs;
            int restinputs=inputs%2;
            if(restinputs==1){
                inputnumber=inputs;
            }
            if(inputs>1){
                ands1=inputs/2;
                for(int i=0;i<ands1;i++){
                    ps.println("CONNECT in"+(i*2+1)+" "+conjname+(i+1)+"in1;");
                    ps.println("CONNECT in"+(i*2+2)+" "+conjname+(i+1)+"in2;");
                }
                int restands1=ands1%2;
                if(restands1==1){
                    number=linebegin+ands1;
                }
                nextlinebegin=ands1;
                ands=ands1;
                while(ands>1){
                    ands=ands/2;
                    int restands=ands%2;
                    for(int i=0;i<ands;i++){
                        ps.println("CONNECT "+conjname+(linebegin+i*2+1)+"out "+conjname+(nextlinebegin+i+1)+"in1;");
                        ps.println("CONNECT "+conjname+(linebegin+i*2+2)+"out "+conjname+(nextlinebegin+i+1)+"in2;");
                    }
                    linebegin=nextlinebegin;
                    nextlinebegin=nextlinebegin+ands;
                    if(inputnumber>0&&number>0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT in"+inputnumber+" "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        inputnumber=-1;
                    }
                    else if(inputnumber<=0&&number>0&&number2>0){
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number2+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        number2=-1;
                        inputnumber=-1;
                        if(restands==1){
                            number2=nextlinebegin-1;
                        }
                    }
                    else if(number<=0&&number2<=0){
                        if(restands==1){
                            number=nextlinebegin;
                        }
                    }
                    else if(inputnumber<=0&&number>0&&number2<=0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                    }
                }
                int lastnumbers=nextlinebegin;
                if(number==lastnumbers){
                    number=-1;
                    if(number2>0){
                        number=number2;
                        number2=-1;
                    }
                }
                else if(number2==lastnumbers){
                    number2=-1;
                }
                if(inputnumber>0&&number>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(number>0&&number2>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number2+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(inputnumber>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                else if(number>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                ps.println("CONNECT "+conjname+lastnumbers+"out out;");
            }
            else{
                ps.println("CONNECT in1 out;");
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
}
class State{
    State next=null;
    String statename;
    boolean firststate;
    int linenumber=0;
    StateChange start;
    StateChange end;
    public State(String statename,boolean firststate,int linenumber){
        this.statename=statename;
        this.firststate=firststate;
        this.linenumber=linenumber;
    }
    public void addStateChange(String[]datastr,int datalength,boolean always,String nextstate,int linenumber,int incount){
         StateChange cur=new StateChange(datastr,datalength,always,nextstate,linenumber,incount);
         if(start==null){
             start=cur;
             end=cur;
         }
         else{
             end.next=cur;
             end=end.next;
         }
    }
    public int find(String[]statename){
        int errors=0;
        StateChange cur=start;
        while(cur!=null){
            boolean found=false;
            for(int i=0;i<statename.length;i++){
                if(statename[i].equals(cur.nextstate)){
                    found=true;
                }
            }
            if(!found){
                System.out.println("error: next state "+cur.nextstate+" in line "+cur.linenumber+" not found");
                errors=errors+1;
            }
            cur=cur.next;
        }
        return errors;
    }
}
class StateChange{
    String[]datastr;
    int datalength;
    boolean always;
    String nextstate;
    int linenumber;
    int incount;
    StateChange next;
    public StateChange(String[]datastr,int datalength,boolean always,String nextstate,int linenumber,int incount){
        this.datastr=datastr;
        this.datalength=datalength;
        this.always=always;
        this.nextstate=nextstate;
        this.linenumber=linenumber;
        this.incount=incount;
    }
}
class DataWord{
    int dwlength=0;
    DataWord next;
    String[]datastr;
    public DataWord(String[]datastr,int dwlength){
        this.datastr=datastr;
        this.dwlength=dwlength;
    }
}
class GloCounter{
    int[]count=new int[0];
    public GloCounter(){
    }
    public void add(int co){
        int n=count.length;
        for(int i=0;i<n;i++){
            if(count[i]==co){
                return;
            }
        }
        int[]count2=new int[n+1];
        for(int i=0;i<n;i++){
            count2[i]=count[i];
        }
        count2[n]=co;
        count=count2;
    }
}
